﻿<!DOCTYPE html>
<html>
<head>
    <title>Hello World</title>
    <link href="scripts/leaflet.css" rel="stylesheet" />

    <link href="scripts/Leaflet.Coordinates-0.1.3.css" rel="stylesheet" />
</head>
<body>
    <label>Zoom: </label>
    <label id="map_view_zoom_label">0</label>
    <div id="map" style="height:calc(100vh - 5em); width:calc(100vw-2em)"></div>

    <script src="https://maps.google.com/maps/api/js?key=AIzaSyCppmfJ8Pl_j5E1hVFm2y1Wn3heMvrW0fo"></script>
    <script src="scripts/leaflet.js"></script>
    <script src="scripts/leaflet-google.js"></script>
    <script src="https://ajax.aspnetcdn.com/ajax/jQuery/jquery-3.3.1.min.js"></script>


    <script src="scripts/Leaflet.Coordinates-0.1.3.min.js"></script>

    <script>
        // add thinkgeo map
        //L.tileLayer.wms('https://{s}.thinkgeo.com/CachedWMSServer/WmsServer.axd', {
        //    subdomains: ['worldmapkit1', 'worldmapkit2', 'worldmapkit3', 'worldmapkit4', 'worldmapkit5', 'worldmapkit6'],
        //    layers: 'OSMWorldMapKitLayer',
        //    format: 'image/png',
        //    styles: 'WorldMapKitDefaultStyle',
        //    version: '1.1.1',
        //    attribution: '<a href="https://thinkgeo.com/map-suite-developer-gis/world-map-kit-sdk/">ThinkGeo</a> | &copy; <a href="https://osm.org/copyright">OpenStreetMap</a> contributors '
        //}).addTo(map);

        var MokaLayer = L.tileLayer('/ShapeFiles/MokaMaps/{z}/{x}/{y}');
        var NaveoLayer = L.tileLayer('/ShapeFiles/NaveoMaps/{z}/{x}/{y}');
        var googleLayer = new L.Google('ROADMAP');
        var googleSat = L.tileLayer('https://{s}.google.com/vt/lyrs=s&x={x}&y={y}&z={z}', { maxZoom: 20, subdomains: ['mt0', 'mt1', 'mt2', 'mt3'] });
        var zonesLayer = L.tileLayer('/InMemory/ShowZones/ed20f533-2919-465b-ac9a-4d6ddc125b1f/{z}/{x}/{y}');
        var imageLayer = L.tileLayer('/Raster/MokaDrone/{z}/{x}/{y}');
        var MokaDistrict = L.tileLayer('/Raster/MokaDistrict/{z}/{x}/{y}', { maxZoom: 25 });
        var tripsLayer = L.tileLayer('/ShapeFiles/ShowTrips/FE791FAF-7210-47DE-AF07-5F8E105EA7D9/{z}/{x}/{y}');
        var imMemoLayer = L.tileLayer('/ShapeFiles/InMemo/{z}/{x}/{y}');

        var routing = L.tileLayer('/Routing/ShowRoute/32d12ff0-8803-457f-aeaa-27c1dc7f3308/{z}/{x}/{y}');
        var openStreet = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors', latlngFormat: 'DM', latlngDesignators: true
        });
        var routeLayer = L.tileLayer('/routing/ShowRoute/ed20f533-2919-465b-ac9a-4d6ddc125b1f.mem|RoutingTmp/{z}/{x}/{y}');
        var blupLayer = L.tileLayer('/ShapeFiles/ShowBLUP/5ae4fbfc-cc8b-403d-bb8e-402b6c4db421/{z}/{x}/{y}', { maxZoom: 35 });
        var showQGISlayer = L.tileLayer('/qgis/ShowLayers/6ae063e2-1eb2-473e-9da8-aa6fc51937bf.txt/{z}/{x}/{y}');
        var circlesLayer = L.tileLayer('/ShapeFiles/Circles/57.5447998046875/-20.2259273529053/{z}/{x}/{y}');
        var BlupCircleLayer = L.tileLayer('/Blup/ShowLayers/653518a1-679b-4465-a089-7c7ecd88e936/{z}/{x}/{y}', { maxZoom: 25 });
        var contour = L.tileLayer('/ShapeFiles/Specifics/Moka/contour/{z}/{x}/{y}', { maxZoom: 25 });
        var rivers = L.tileLayer('/ShapeFiles/Specifics/Moka/rivers/{z}/{x}/{y}', { maxZoom: 25 });
        var sb = L.tileLayer('/ShapeFiles/Specifics/Test/SBoundary/{z}/{x}/{y}', { maxZoom: 25 });
        var FA = L.tileLayer('/FixedAssets/ShowLayers/12209d47-6dfd-4c10-b479-13b8aa65fedc/{z}/{x}/{y}', { maxZoom: 25 });

        var none = L.tileLayer('');
        var qgis = L.tileLayer('/qgis/QGISMaps/0/abc/{z}/{x}/{y}');
        var qgisTst = L.tileLayer('/qgis/QGISMaps/Test');

        var baseUrl = 'http://localhost:27081/';

        var map = L.map('map', {
            center: [-20.247026, 57.548697],
            zoom: 11,
            maxZoom: 25
        });

        var osmLayer = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', { maxZoom: 25 }).addTo(map);

        // add osmLayer to baseMap layers
        var baseMaps = {
            "OSM": osmLayer,
            "googleSat": googleSat,
            "none": none
        };

        // overlays layer object
        var overlays = {
            "BLUP": blupLayer
            , "BlupCircleLayer": BlupCircleLayer
            , "FixedAssets": FA
            , "Rivers": rivers
            , "imageLayer": imageLayer
            , "MokaDistrict": MokaDistrict
            , "sb": sb
            , "qgis": qgis
            , "qgisTst": qgisTst
        };


        // top right box control
        var layerControl = L.control.layers(baseMaps, overlays).addTo(map);

        //add standard controls
        L.control.coordinates().addTo(map);
        //add configured controls
        L.control.coordinates({
            position: "bottomleft",
            decimals: 4,
            decimalSeperator: ",",
            labelTemplateLat: "Latitude: {y}",
            labelTemplateLng: "Longitude: {x}"
        }).addTo(map);
        L.control.coordinates({
            position: "topright",
            useDMS: true,
            labelTemplateLat: "N {y}",
            labelTemplateLng: "E {x}",
            useLatLngOrder: true
        }).addTo(map);

        map.on('moveend', function (event) {
            document.getElementById('map_view_zoom_label').innerHTML = map.getZoom();
        });

        //map.on('click', function (e) {
        //    const data = {
        //        x: e.latlng.lng,
        //        y: e.latlng.lat,
        //        userToken: 'ed20f533-2919-465b-ac9a-4d6ddc125b1f'
        //    };

        //    $.ajax({
        //        url: '/Query/InMemoryZone',
        //        type: 'POST',
        //        data: JSON.stringify(data),
        //        contentType: 'application/json; charset=utf-8',
        //        dataType: 'json'
        //    }).done(function (data) {
        //        if (data.success) {
        //            L.popup()
        //                .setLatLng(e.latlng)
        //                .setContent(data.name)
        //                .openOn(map);
        //        }
        //    });
        //});

        //var worldLayer = L.tileLayer('http://localhost:59598/HelloWorld/MauritiusV2/{z}/{x}/{y}').addTo(map);

        //var worldLayer = L.tileLayer('/ShapeFiles/Tile/{z}/{x}/{y}');//.addTo(map);
        //var googleLayer = new L.Google('ROADMAP');

        //var map = L.map('map', {
        //    center: [-20.027026, 57.548697],
        //    zoom: 10,
        //    layers: [worldLayer, googleLayer]
        //});

        //function updateLayer(layerId) {
        //    worldLayer.setUrl('/HelloWorld/Tile/' + layerId + '/{z}/{x}/{y}');
        //    worldLayer.redraw();
        //}
    </script>

    <script>
        //Running ajax call from controller
        //function ajaxBuildIndex() {
        //    const Http = new XMLHttpRequest();

        //    Http.onreadystatechange = function () {
        //        if (this.readyState == 4 && this.status == 200) {
        //            alert("fni")
        //        }
        //    };

        //    Http.open("GET", '/ShapeFiles/BuildIndex');
        //    Http.send();
        //}
        //ajaxBuildIndex();
    </script>

    <script>
        // create new layers by looping on list and adding to overlay object
        function setOverlays(apiList) {
            for (var i = 0; i < apiList.length; i++) {
                var tile = L.tileLayer(baseUrl+ 'qgis/QGISMaps/' + apiList[i].id + '/null/{z}/{x}/{y}', { maxZoom: 25 });

                if (apiList[i].ticked) {
                    tile.addTo(map);
                }
                layerControl.addOverlay(tile, apiList[i].name);
            }
            //setMokaVillagesLayers();
        }

        function setMokaVillagesLayers() {
            var melroseLayer = L.tileLayer(baseUrl + 'qgis/QGISMaps/MokaVillages_0830a17c_a76d_49b8_b571_01b4109eaea9/MELROSE, LA LAURA MALENGA/{z}/{x}/{y}', { maxZoom: 25 }).addTo(map);
            var lalauraLayer = L.tileLayer(baseUrl + 'qgis/QGISMaps/MokaVillages_0830a17c_a76d_49b8_b571_01b4109eaea9/LA LAURA MALENGA/{z}/{x}/{y}', { maxZoom: 25 }).addTo(map);

            layerControl.addOverlay(melroseLayer, "melroseLayer");
            layerControl.addOverlay(lalauraLayer, "lalauraLayer");

        }


        // get layers from server callback
        function getResponse(xhttp) {
            var apiList = [];
            apiList = JSON.parse(xhttp.response);
            setOverlays(apiList);
        }


        // get layers list from server
        function LoadApiList() {
            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function () {
                if (this.readyState == 4 && this.status == 200) {
                    getResponse(this);// response callback
                }
            };
            xhttp.open("GET", baseUrl + "qgis/getQGISLayers", true);
            xhttp.send();
        }

        LoadApiList();
        // end get layers list from server


        // add new layers
        //var layer1 = L.tileLayer('URL', {maxZoom: 21}).addTo(mymap);
        //layerControl.addOverlay(tile, "NAME");
        //copy and paste to add more layers
    </script>
</body>
</html>
